import * as React from 'react';
import { Route, Switch } from 'react-router-dom';

import Signin from '../views/member/Signin';

const routes = (
    <Switch>
        <Route exact path='/' />
        <Route path='/signin' component={Signin} />
        <Route component={NoMatch}/>
    </Switch>

);

export default routes;

const _routes = [
  {
    path: '/signin',
    component: Signin,
  },
  {
    path: '/signup',
    component: Signup,
  },
  {
    path: '/forgot_password',
    component: ForgotPassword,
  },
  {
    path: '/email_confirm',
    component: EmailConfirm,
  },
  {
    path: '/',
    component: Home,
    routes: [
      {
        path: '/monitoring',
        component: Monitoring,
        routes: [
            {
                path: '/probe',
                component: Probe,
                routes: [
                    {
                        path: '/list',
                        component: Probe,
                    },
                    {
                        path: '/noauth',
                        component: NoAuthProbe,
                    },
                    {
                        path: '/setup',
                        component: ProbeSetup,
                    },
                ],
            },
            {
                path: '/sensor',
                component: Sensor,
            },
        ],
      },
      {
        path: '/infrastructure',
        component: ,
        routes: [
            {
                path: '/maps',
                component: InfrastructureMaps,
            },
            {
                path: '/targets',
                component: Targets,
            },
        ],
      },
      {
        path: '/dashboard',
        component: Dashboard,
      },
      {
        path: '/metrics',
        component: Metrics,
      },
      {
        path: '/alerts',
        component: Alerts,
      },
      {
        path: '/history',
        component: History,
      },
      {
        path: '/settings',
        component: Settings,
      },
      {
        path: '/notifications',
        component: Notifications,
      },
      {
        path: '/account',
        component: ,
        routes: [
            {
                path: '/signout',
                component: Signout,
            },
            {
                path: '/profile',
                component: Profile,
            },
            {
                path: '/preferences',
                component: Preferences,
            },
            {
                path: '/help',
                component: Help,
            },
        ],
      },
    ],
  },
];
