/**
 * Created by geek on 17. 7. 4.
 */

import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';


import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import EmailAuth from '@overflow/email/api/model/EmailAuth';

import EmailAuthService from '@overflow/email/api/service/EmailAuthService';
import * as ModifyAction from '../action/modify';
import ModifyPayload from '../payload/ModifyPayload';

function* modify(action: Action<ModifyPayload>): SagaIterator {
  try {
    const ea = action.payload.emailAuth;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const emailAuth = yield call(AppContext.getService<EmailAuthService>().modify, ea);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(ModifyAction.requestSuccess(emailAuth));
  } catch (e) {
    yield put(ModifyAction.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchEmailModify(): SagaIterator {
  yield takeLatest(ModifyAction.REQUEST, modify);
}
