import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';


import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import Member from '../../api/model/Member';
import MemberService from '../../api/service/MemberService';
import * as ModifyActions from '../action/modify';
import ModifyPayload from '../payload/ModifyPayload';

function* modify(action: Action<ModifyPayload>): SagaIterator {
  try {
    const tempMember = action.payload.member;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const member = yield call(AppContext.getService<MemberService>().modify, tempMember);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(ModifyActions.requestSuccess(member));
  } catch (e) {
    yield put(ModifyActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchMemberModify(): SagaIterator {
  yield takeLatest(ModifyActions.REQUEST, modify);
}
