import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';

import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import SensorItem from '../../api/model/SensorItem';
import SensorItemService from '../../api/service/SensorItemService';
import * as ItemReadActions from '../action/item_read';
import ItemReadPayload from '../payload/ItemReadPayload';

function* readItem(action: Action<ItemReadPayload>): SagaIterator {
  try {
    const {id} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const retSensor = yield call(AppContext.getService<SensorItemService>().read, id);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(ItemReadActions.requestSuccess(retSensor));
  } catch (e) {
    yield put(ItemReadActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchReadItem(): SagaIterator {
  yield takeLatest(ItemReadActions.REQUEST, readItem);
}
