import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';

import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import Sensor from '../../api/model/Sensor';
import SensorService from '../../api/service/SensorService';
import * as StartActions from '../action/start';
import StartPayload from '../payload/StartPayload';

function* start(action: Action<StartPayload>): SagaIterator {
  try {
    const {sensor} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const retSensor = yield call(AppContext.getService<SensorService>().start, sensor);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(StartActions.requestSuccess(retSensor));
  } catch (e) {
    yield put(StartActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchStart(): SagaIterator {
  yield takeLatest(StartActions.REQUEST, start);
}
