import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';

import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import Sensor from '../../api/model/Sensor';
import SensorService from '../../api/service/SensorService';
import * as StopActions from '../action/stop';
import StopPayload from '../payload/StopPayload';

function* stop(action: Action<StopPayload>): SagaIterator {
  try {
    const {sensor} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const retSensor = yield call(AppContext.getService<SensorService>().stop, sensor);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(StopActions.requestSuccess(retSensor));
  } catch (e) {
    yield put(StopActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchStop(): SagaIterator {
  yield takeLatest(StopActions.REQUEST, stop);
}
